/*
 * 自定义查询子项
 */

using System;
using System.Web;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Http;
using Microsoft.Extensions.Logging;
using Microsoft.Extensions.Options;
using MySystem.Models;
using Library;
using LitJson;
using MySystemLib;

namespace MySystem.Areas.Admin.Controllers
{
    [Area("Admin")]
    [Route("Admin/[controller]/[action]")]
    public class CustomQuerySubController : BaseController
    {
        public CustomQuerySubController(IHttpContextAccessor accessor, ILogger<BaseController> logger, IOptions<Setting> setting) : base(accessor, logger, setting)
        {
            OtherMySqlConn.connstr = ConfigurationManager.AppSettings["SqlConnStr"].ToString();
        }

        #region 自定义查询子项列表

        /// <summary>
        /// 根据条件查询自定义查询子项列表
        /// </summary>
        /// <returns></returns>
        public IActionResult Index(CustomQuerySub data, string right, string ParentId)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;
            ViewBag.ParentId = ParentId;


            return View();
        }

        #endregion

        #region 根据条件查询自定义查询子项列表

        /// <summary>
        /// 自定义查询子项列表
        /// </summary>
        /// <returns></returns>
        public JsonResult IndexData(CustomQuerySub data, int page = 1, int limit = 30)
        {

            Dictionary<string, string> Fields = new Dictionary<string, string>();
            Fields.Add("ParentId", "1");

            Fields.Add("Title", "1"); //标题


            string condition = " and Status>-1";


            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("CustomQuerySub", Fields, "Id desc", "0", page, limit, condition);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {

            }
            return Json(obj);
        }

        #endregion

        #region 增加自定义查询子项

        /// <summary>
        /// 增加或修改自定义查询子项信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Add(string right, string ParentId)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;
            ViewBag.ParentId = ParentId;


            return View();
        }

        #endregion

        #region 增加自定义查询子项

        /// <summary>
        /// 增加或修改自定义查询子项信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Add(CustomQuerySub data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();

            Fields.Add("SqlContent", data.SqlContent); //sql语句
            Fields.Add("Title", data.Title); //标题
            Fields.Add("AdminNames", data.AdminNames); //后台账号
            Fields.Add("ParentId", data.ParentId); //父级
            Fields.Add("Kind", data.Kind); //类型
            Fields.Add("Alias", data.Alias); //别名
            Fields.Add("DatabaseConnect", data.DatabaseConnect); //数据库
            Fields.Add("DataKey", data.DataKey); //字典key
            Fields.Add("DataText", data.DataText); //字典key

            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            int Id = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Add("CustomQuerySub", Fields, 0);
            AddSysLog(data.Id.ToString(), "CustomQuerySub", "add");
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 修改自定义查询子项

        /// <summary>
        /// 增加或修改自定义查询子项信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Edit(string right, string ParentId, int Id = 0)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;
            ViewBag.ParentId = ParentId;


            CustomQuerySub editData = db.CustomQuerySub.FirstOrDefault(m => m.Id == Id) ?? new CustomQuerySub();
            ViewBag.data = editData;
            return View();
        }

        #endregion

        #region 修改自定义查询子项

        /// <summary>
        /// 增加或修改自定义查询子项信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Edit(CustomQuerySub data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();

            Fields.Add("SqlContent", data.SqlContent); //sql语句
            Fields.Add("Title", data.Title); //标题
            Fields.Add("AdminNames", data.AdminNames); //后台账号
            Fields.Add("ParentId", data.ParentId); //父级
            Fields.Add("Kind", data.Kind); //类型
            Fields.Add("Alias", data.Alias); //别名
            Fields.Add("DatabaseConnect", data.DatabaseConnect); //数据库
            Fields.Add("DataKey", data.DataKey); //字典key
            Fields.Add("DataText", data.DataText); //字典key

            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("CustomQuerySub", Fields, data.Id);
            AddSysLog(data.Id.ToString(), "CustomQuerySub", "update");
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 删除自定义查询子项信息

        /// <summary>
        /// 删除自定义查询子项信息
        /// </summary>
        /// <returns></returns>
        public string Delete(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "CustomQuerySub", "del");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", -1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("CustomQuerySub", Fields, id);
            }
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 开启

        /// <summary>
        /// 开启
        /// </summary>
        /// <returns></returns>
        public string Open(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "CustomQuerySub", "open");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("CustomQuerySub", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 关闭

        /// <summary>
        /// 关闭
        /// </summary>
        /// <returns></returns>
        public string Close(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "CustomQuerySub", "close");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 0);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("CustomQuerySub", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 排序
        /// <summary>
        /// 排序
        /// </summary>
        /// <param name="Id"></param>
        public string Sort(int Id, int Sort)
        {
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Sort("CustomQuerySub", Sort, Id);

            AddSysLog(Id.ToString(), "CustomQuerySub", "sort");
            return "success";
        }
        #endregion

        #region 导入数据
        /// <summary>
        /// 导入数据
        /// </summary>
        /// <param name="ExcelData"></param>
        public string Import(string ExcelData)
        {
            ExcelData = HttpUtility.UrlDecode(ExcelData);
            JsonData list = JsonMapper.ToObject(ExcelData);
            for (int i = 1; i < list.Count; i++)
            {
                JsonData dr = list[i];

                db.CustomQuerySub.Add(new CustomQuerySub()
                {
                    CreateDate = DateTime.Now,
                    UpdateDate = DateTime.Now,

                });
                db.SaveChanges();
            }
            AddSysLog("0", "CustomQuerySub", "Import");
            return "success";
        }
        #endregion

        #region 导出Excel

        /// <summary>
        /// 导出Excel
        /// </summary>
        /// <returns></returns>
        public JsonResult ExportExcel(CustomQuerySub data)
        {
            Dictionary<string, string> Fields = new Dictionary<string, string>();
            Fields.Add("Title", "1"); //标题


            string condition = " and Status>-1";


            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("CustomQuerySub", Fields, "Id desc", "0", 1, 20000, condition, "", false);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {

            }

            Dictionary<string, object> result = new Dictionary<string, object>();
            result.Add("Status", "1");
            result.Add("Info", "Excel报表-" + DateTime.Now.ToString("yyyy-MM-ddTHH:mm:ss") + ".xlsx");
            result.Add("Obj", diclist);
            Dictionary<string, object> ReturnFields = new Dictionary<string, object>();

            result.Add("Fields", ReturnFields);
            AddSysLog("0", "CustomQuerySub", "ExportExcel");
            return Json(result);
        }

        #endregion

    }
}
